#ifndef __MAP_H__
#define __MAP_H__

/* Map.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include <string>
#include "Tile.h"

/* Class Map:
 * 
 * Stores the entire map, which consists of
 * - Tiles
 * - More to add later
 */

class Map {
public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Constructor and destructor
  Map();
  ~Map();
  
  // Generate a random map
  void Random(unsigned short width, unsigned short height);
  
  // Get an individual tile
  Tile *GetTile(unsigned short X, unsigned short Y);
  
protected:
  // Width and height of the map
  unsigned short Width;
  unsigned short Height;
  
  // Pointer to the map data
  Tile **Tiles;
};

#endif // __MAP_H__
